AbstractGrailsControllerHelper (Grails 2.4.4)
Date: 2014-10-28

Package: org.codehaus.groovy.grails.web.servlet.mvc

## [Java] Class AbstractGrailsControllerHelper

- org.codehaus.groovy.grails.web.servlet.mvc.AbstractGrailsControllerHelper

- All Implemented Interfaces and Traits:
    org.springframework.context.ApplicationContextAware, GrailsApplicationAware, org.springframework.web.context.ServletContextAware

      public abstract class AbstractGrailsControllerHelper
      extends java.lang.Object

  Processes Grails controller requests and responses.

  Authors:
    Graeme Rocher
    Stephane Maldini
  Since:
    2.0

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected java.util.Map<java.lang.Class<?>, java.lang.Boolean>` | `allowedMethodsSupport` |
    `protected GrailsApplication` | `application` |
    `protected org.springframework.context.ApplicationContext` | `applicationContext` |
    `protected boolean` | `developerMode` |
    `protected boolean` | `developmentMode` |
    `protected GrailsApplicationAttributes` | `grailsAttributes` |
    `protected javax.servlet.ServletContext` | `servletContext` |

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `protected org.springframework.web.servlet.ModelAndView` | `executeAction(groovy.lang.GroovyObject controller, java.lang.String actionName, java.lang.String viewName, GrailsWebRequest webRequest, java.util.Map params)` Invokes the action defined by the webRequest for the given arguments.
    `GrailsControllerClass` | `getControllerClassByName(java.lang.String name)`
    `GrailsControllerClass` | `getControllerClassByURI(java.lang.String uri)`
    `groovy.lang.GroovyObject` | `getControllerInstance(GrailsControllerClass controllerClass)`
    `GrailsApplicationAttributes` | `getGrailsAttributes()`
    `javax.servlet.ServletContext` | `getServletContext()`
    `java.lang.Object` | `handleAction(groovy.lang.GroovyObject controller, java.lang.Object action, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)`
    `java.lang.Object` | `handleAction(groovy.lang.GroovyObject controller, java.lang.Object action, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, java.util.Map params)`
    `org.springframework.web.servlet.ModelAndView` | `handleActionResponse(groovy.lang.GroovyObject controller, java.lang.Object returnValue, GrailsWebRequest webRequest, java.util.Map chainModel, java.lang.String closurePropertyName, java.lang.String viewName)`
    `org.springframework.web.servlet.ModelAndView` | `handleURI(java.lang.String uri, GrailsWebRequest request)`
    `org.springframework.web.servlet.ModelAndView` | `handleURI(java.lang.String originalUri, GrailsWebRequest grailsWebRequest, java.util.Map params)`
    `protected boolean` | `hasCompileTimeSupportForAllowedMethods(groovy.lang.GroovyObject controller)`
    `protected java.lang.Object` | `invoke(groovy.lang.GroovyObject controller, java.lang.Object action)`
    `protected java.lang.Object` | `retrieveAction(groovy.lang.GroovyObject controller, java.lang.String actionName, javax.servlet.http.HttpServletResponse response)`
    `void` | `setApplicationContext(org.springframework.context.ApplicationContext applicationContext)`
    `void` | `setGrailsApplication(GrailsApplication application)`
    `void` | `setServletContext(javax.servlet.ServletContext servletContext)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### protected java.util.Map<java.lang.Class<?>, java.lang.Boolean> allowedMethodsSupport

    - #### protected GrailsApplication application

    - #### protected org.springframework.context.ApplicationContext applicationContext

    - #### protected final boolean developerMode

    - #### protected boolean developmentMode

    - #### protected GrailsApplicationAttributes grailsAttributes

    - #### protected javax.servlet.ServletContext servletContext

  - ### Method Detail

    - #### @java.lang.SuppressWarnings({ "unchecked", "rawtypes" }) protected org.springframework.web.servlet.ModelAndView executeAction(groovy.lang.GroovyObject controller, java.lang.String actionName, java.lang.String viewName, GrailsWebRequest webRequest, java.util.Map params)

      Invokes the action defined by the webRequest for the given arguments.

      Parameters:
        `controller` - The controller instance
        `actionName` - The current action
        `viewName` - The name of the view to delegate to if necessary
        `webRequest` - the current web Request
        `params` - A map of parameters
      Returns:
        A Spring ModelAndView instance

    - #### public GrailsControllerClass getControllerClassByName(java.lang.String name)

    - #### public GrailsControllerClass getControllerClassByURI(java.lang.String uri)

    - #### public groovy.lang.GroovyObject getControllerInstance(GrailsControllerClass controllerClass)

    - #### public GrailsApplicationAttributes getGrailsAttributes()

    - #### public javax.servlet.ServletContext getServletContext()

    - #### public java.lang.Object handleAction(groovy.lang.GroovyObject controller, java.lang.Object action, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)

    - #### @java.lang.SuppressWarnings("rawtypes") public java.lang.Object handleAction(groovy.lang.GroovyObject controller, java.lang.Object action, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, java.util.Map params)

    - #### @java.lang.SuppressWarnings({ "unchecked", "rawtypes" }) public org.springframework.web.servlet.ModelAndView handleActionResponse(groovy.lang.GroovyObject controller, java.lang.Object returnValue, GrailsWebRequest webRequest, java.util.Map chainModel, java.lang.String closurePropertyName, java.lang.String viewName)

    - #### public org.springframework.web.servlet.ModelAndView handleURI(java.lang.String uri, GrailsWebRequest request)

    - #### @java.lang.SuppressWarnings("rawtypes") public org.springframework.web.servlet.ModelAndView handleURI(java.lang.String originalUri, GrailsWebRequest grailsWebRequest, java.util.Map params)

    - #### protected boolean hasCompileTimeSupportForAllowedMethods(groovy.lang.GroovyObject controller)

    - #### protected java.lang.Object invoke(groovy.lang.GroovyObject controller, java.lang.Object action)

    - #### protected java.lang.Object retrieveAction(groovy.lang.GroovyObject controller, java.lang.String actionName, javax.servlet.http.HttpServletResponse response)

    - #### public void setApplicationContext(org.springframework.context.ApplicationContext applicationContext)

    - #### public void setGrailsApplication(GrailsApplication application)

    - #### public void setServletContext(javax.servlet.ServletContext servletContext)